﻿@model Jb.Framework.Common.Forms.USCFInfo
@{
    var textBoxHtmlAttr = new Dictionary<string, object>();
    textBoxHtmlAttr.Add("class", " form-control");
    if (Model.IsRequired)
    {
        textBoxHtmlAttr.Add("data-val", "true");
        textBoxHtmlAttr.Add("data-Val-Required", "please complete all USCF field");
    }
}
@Html.GenerateHiddenFields(Model)

<div class="" style="width:100%;float:left;display: @(Model.VisibleMode != Jb.Framework.Common.Forms.VisibilityMode.Both && Model.VisibleMode != (Jb.Framework.Common.Forms.VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    <div class="form-title">
        <h3 class="jb-section-title">Provide USCF</h3>
    </div>
    <div>
        <div class="form-group JbFormControll JbTextBox" style="width:100%">
            @Html.LabelFor(m => m.UscfId, new { @class = Model.IsRequired ? "req" : "", @style = "display:block" })
            @Html.TextBoxFor(m => m.UscfId, textBoxHtmlAttr.AddAttr("id", Model.ElementId + "UscfId").AddAttr("placeholder", "Enter ID to look up your membership data").AddAttr("style", "float:left;width: Calc(100% - 120px);"))
            <button type="button" class="btn btn-primary btn-mini lookup-btn UscfId-button" id="@string.Format("{0}_LookUpBtn", Model.ElementId)" style="width:120px" data-loading-text="Looking up...">ID look up</button>
        </div>
        <div class="form-group JbFormControll JbTextBox">
            @Html.LabelFor(m => m.PlayerName)
            @Html.TextBoxFor(m => m.PlayerName, "id", new { id = Model.ElementId + "PlayerName", placeholder = "Start typing last name to look up USCF ID", @class = "form-control" })
        </div>
        <div class="form-group JbFormControll JbTextBox">
            @Html.LabelFor(m => m.UscfRatingReg, new { @class = Model.IsRequired ? "req" : "" })
            @Html.TextBoxFor(m => m.UscfRatingReg, textBoxHtmlAttr.AddAttr("id", Model.ElementId + "UscfRatingReg"))
        </div>
        <div class="form-group JbFormControll JbTextBox">
            @Html.LabelFor(m => m.UscfExpiration, new { @class = Model.IsRequired ? "req" : "" })
            @Html.TextBoxFor(m => m.UscfExpiration, textBoxHtmlAttr.AddAttr("id", Model.ElementId + "UscfExpiration"))
        </div>
    </div>
</div>
<script type="text/javascript">
    $(function () {
        var playerName = "#" + '@Model.ElementId' + "PlayerName";
        var uscfId = "#" + '@Model.ElementId' + "UscfId";
        var uscfExpiration = "#" + '@Model.ElementId' + "UscfExpiration";
        var uscfRatingReg = "#" + '@Model.ElementId' + "UscfRatingReg";
        var btnId = "#" + '@string.Format("{0}_LookUpBtn", Model.ElementId)';

        $(playerName).autocomplete({
            source: function (request, response) {
                $.ajax({
                    url: '@Url.Action("UscfIdSearch", "Engine")',
                    dataType: "json",
                    data: {
                        term: request.term
                    },
                    success: function (data) {
                        response($.map(data, function (item) {
                            return {
                                label: item.Name + "-->" + item.Id,
                                value: item.Name
                            };
                        }));
                    }
                });
            },
            minLength: 2,
            delay: 500,
            search: function (event, ui) {
                $(playerName).addClass("loading");
                return true;
            },
            response: function (event, ui) {
                $(playerName).removeClass("loading");
            },
            select: function (event, ui) {
                var s = new String(ui.item.label);
                var ss = s.split("-->");
                $(uscfId).val(ss[1]);

                loadUscf();
            },
            change: function (event, ui) {
            },
            error: function (jqXHR, textStatus, errorThrown) {
                $(playerName).removeClass("loading");
            }
        });

        $(btnId).click(function (event) {
            event.preventDefault();
            event.stopPropagation();

            loadUscf();
        });

        var loadUscf = function () {

            $(btnId).addClass("loading");

            $.ajax({
                url: '@Url.Action("UscfMemSearch", "Engine")',
                type: "GET",
                dataType: "json",
                data: {
                    term: $(uscfId).val()
                },
                success: function (data) {
                    $(uscfId).removeClass("loading");
                    // data[0] is id
                    $(uscfExpiration).val(data[1]);
                    $(playerName).val(data[2]);
                    $(uscfRatingReg).val(data[3]);
                    //$("#UscfRatingQuick").val(data[4]);
                    //$("#FideId").val(data[5]);
                    //$("#FideRating").val(data[6]);
                },
                complete: function (jqXHR, textStatus) {
                    $(btnId).removeClass("loading");
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $(btnId).removeClass("loading");
                }
            });
        }

    });



</script>

@Scripts.Render("~/Scripts/Libraries/jQuery/jQueryUi/jquery-ui-1.10.4.min.js")
@Styles.Render("~/Content/Frameworks/JqueryUI/jquery-ui.min.css")